
from PySteppables import *
import CompuCell
import sys

from random import random




class AdvancedCellsortStetppable(SteppableBasePy):    

    def __init__(self,_simulator,_frequency=10):
        SteppableBasePy.__init__(self,_simulator,_frequency)
        
    def start(self):
        
        for cell in self.cellList:
            cell.lambdaVolume=2.0
            cell.targetVolume=25        
            
            
            # access/modification of a dictionary attached to cell - make sure to decalare in main script that you will use such attribute
            CompuCell.getPyAttrib(cell)["Counter"]=0            
#             xyz=CompuCell.getPyAttrib(cell)["Counter"]=0
#             xyz["Counter"]=0
            
            
            
            
            
    def step(self,mcs):        
        field=CompuCell.getConcentrationField(self.simulator,"FGF")
        
        pt=CompuCell.Point3D()
        
        for cell in self.cellList:
            
            if cell.type==1:
                
                xCOM=int(cell.xCOM)
                yCOM=int(cell.yCOM)
                
                pt.x=xCOM
                pt.y=yCOM
                
                conc=field.get(pt)
#                 print "conc=",conc," targetVolume=",cell.targetVolume
                
                cell.targetVolume+=0.002*conc 
                
#                 print " AFTER targetVolume=",cell.targetVolume
#                 print "self.dim=",self.dim.x
                
            
                    
        
        
from PySteppables import *
from PySteppablesExamples import MitosisSteppableBase
import CompuCell
import sys

from PlayerPython import *
from math import *


class MitosisSteppable(MitosisSteppableBase):
    def __init__(self,_simulator,_frequency=1):
        MitosisSteppableBase.__init__(self,_simulator, _frequency)
    
    def step(self,mcs):
        # print "INSIDE MitosisSteppable"
        cells_to_divide=[]
        for cell in self.cellList:
            if cell.volume>50:
                
                cells_to_divide.append(cell)
                
        for cell in cells_to_divide:
            # to change mitosis mode leave one of the below lines uncommented
            self.divideCellRandomOrientation(cell)
            # self.divideCellOrientationVectorBased(cell,1,0,0)                 # this is a valid option
            # self.divideCellAlongMajorAxis(cell)                               # this is a valid option
            # self.divideCellAlongMinorAxis(cell)                               # this is a valid option

    def updateAttributes(self):
        parentCell=self.mitosisSteppable.parentCell
        childCell=self.mitosisSteppable.childCell
        
        parentCell.targetVolume/=2
        
        
        childCell.targetVolume=parentCell.targetVolume
        childCell.lambdaVolume=parentCell.lambdaVolume

        # incrementing existing entry in the dictionary
        dap=CompuCell.getPyAttrib(parentCell)
        dap["Counter"]+=1
        
        if dap["Counter"]>=2:
            print "cell.id=",parentCell.id," divided more than twice"
            
        # adding entry to dictionary
        dac=CompuCell.getPyAttrib(childCell)
        dac["Counter"]=0

        
        #######################
        if random()<0.5:
            childCell.type=parentCell.type
        else:
            childCell.type=3    
            
            
            
            
            
            
            
        
